#include <CytronWiFiShield.h>
#include <CytronWiFiClient.h>
#include <SoftwareSerial.h>
#define WiFi wifi

ESP8266Client client;
char wifissid[] = ""; // your network SSID (name)
char wifipass[] = ""; // your WPA network password

const char devid[] = ""; //Scenario : "The mailbox is open"

//Numeric Pin where you connect your switch
uint8_t pinDevid1 = 7; // Example : the mailbox switch is connect to the Pin 3

// Debug mode
boolean DEBUG = true;
char serverName[] = "api.pushingbox.com";
boolean pinDevid1State = false; // Save the last state of the Pin for DEVID1
boolean lastConnected = false; 

void setup() {
Serial.begin (115200);
pinMode(pinDevid1, INPUT_PULLUP);
Serial.print("Connecting to ");
Serial.println(wifissid);

if (!WiFi.begin(2, 3)) {
Serial.println("WiFi shield not present");
while (true); // don't continue
}

while (!WiFi.connectAP(wifissid,wifipass)) {
delay(500);
Serial.print(".");
}

Serial.println("");
Serial.println("WiFi connected"); 
Serial.println("IP address: ");
Serial.println(WiFi.localIP());
Serial.println();

}

void loop(){
////
// Listening for the pinDevid1 state
////
  if (digitalRead(pinDevid1) == LOW && pinDevid1State == false) // switch on pinDevid1 is ON
  {
    if(DEBUG){Serial.println("pinDevid1 is activated");}
    delay(200);
    pinDevid1State = true;
    sendToPushingBox();
  }
}

//Function for sending the request to PushingBox
void sendToPushingBox(){
  //client.stop();
  if(DEBUG){Serial.println("connecting...");}
  if(client.connect(serverName, 80)) { 
    Serial.println("connected\r\nsending request");
    String data="GET /pushingbox?devid=";
    data+=devid;
    data+=" HTTP/1.1\r\n";
    data+="Host: api.pushingbox.com\r\n";
    data+="Connection: close\r\n\r\n";
    client.print(data);

    //check reply from pushingbox server
    rcvReplyFromServer();
    
    //disconnecting from pushingbox server
    if(DEBUG){Serial.println("disconnecting.");}
    client.stop();
  } 
  else { 
    if(DEBUG){Serial.println("connection failed");} 
  } 
}

void rcvReplyFromServer(){
  //5 sec to wait for reply from the server
  int i=5000;
  while (client.available()<=0&&i--){
    delay(1);
    if(i==1) {
      Serial.println(F("Timeout"));
      return;
      }
  }
  // Read all the lines of the reply from server and print them to Serial
 
  while(client.available()){
    Serial.write(client.read());
  }

  Serial.println("Receive reply completed");
}

